//+------------------------------------------------------------------+
//|                                                      OILMACD.mq4 |
//| Original idea by OILFXPRO                                        |
//|                                                                  |
//|                        Copyright  2008, http://www.forex-tsd.com|
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, FOREX-TSD"
#property link      "http://www.forex-tsd.com/expert-advisors-metatrader-4/11482-oilfxpro-trendmaster-double-macd-ea-freeversion.html#post174184"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Black
#property  indicator_color2  DodgerBlue
#property  indicator_color3  Crimson
#property  indicator_width2  2
#property  indicator_width3  2
#property  indicator_level1  0.0007
#property  indicator_level2  -0.0007
#property  indicator_levelcolor White
#property  indicator_levelstyle 0

extern int  Fast_MA=12;
extern int  Slow_MA=18;

//---- indicator buffers
double     ExtBuffer0[];
double     ExtBuffer1[];
double     ExtBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   //---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   IndicatorDigits(Digits+1);
   SetIndexDrawBegin(0,Slow_MA);
   SetIndexDrawBegin(1,Slow_MA);
   SetIndexDrawBegin(2,Slow_MA);
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("OILMACD("+Fast_MA+","+Slow_MA+")");
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Awesome Oscillator                                               |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd
   for(int i=0; i<limit; i++)
      ExtBuffer0[i]=iMA(NULL,0,Fast_MA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,Slow_MA,0,MODE_EMA,PRICE_CLOSE,i);
//---- dispatch values between 2 buffers
   bool up=true;
   for(i=limit-1; i>=0; i--)
     {
      current=ExtBuffer0[i];
      prev=ExtBuffer0[i+1];
      if(current>prev) up=true;
      if(current<prev) up=false;
      if(!up)
        {
         ExtBuffer2[i]=current;
         ExtBuffer1[i]=0.0;
        }
      else
        {
         ExtBuffer1[i]=current;
         ExtBuffer2[i]=0.0;
        }
     }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

